# -*- coding: utf-8 -*-

"""
/***************************************************************************
 ForstProcessing
                                 A QGIS plugin
 ForstProcessing
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                              -------------------
        begin                : 2018-11-13
        copyright            : (C) 2018 by CHL
        email                : christina_ludwig@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

__author__ = 'CHL'
__date__ = '2018-11-13'
__copyright__ = '(C) 2018 by CHL'

# This will get replaced with a git SHA1 when you do a git archive

__revision__ = '$Format:%H$'

import os
from qgis.PyQt.QtCore import QCoreApplication
from qgis.PyQt.QtGui import QIcon
from qgis.core import (QgsProcessing, QgsVectorLayer, QgsField, QgsSettings, QgsProject,
                       QgsCoordinateReferenceSystem, QgsPointXY, QgsPoint,
                       QgsProcessingAlgorithm,
                       QgsProcessingParameterString, QgsFeatureRequest, QgsMapLayer,
                       QgsProcessingParameterFeatureSink, QgsFeature, QgsGeometry, QgsPalLayerSettings, QgsTextFormat,
                       QgsVectorLayerSimpleLabeling)
from qgis.utils import iface
from .hyperlink_dialog import HyperlinkDialog
from .help_dialog import HelpDialog
from .utils import *
from ..resources import *

class Hyperlink(QgsProcessingAlgorithm):
    """
     This is an example algorithm that takes a vector layer and
     creates a new identical one.

     It is meant to be used as an example of how to create your own
     algorithms and explain methods and variables used to do it. An
     algorithm like this will be available in all elements, and there
     is not need for additional work.

     All Processing algorithms should extend the QgsProcessingAlgorithm
     class.
     """

    # Constants used to refer to parameters and outputs. They will be
    # used when calling the algorithm from another algorithm, or when
    # calling from the QGIS console.

    ADDRESS = ""
    OUTPUT = ""
    parent = None
    RADIO_1 = False
    RADIO_2 = False
    RADIO_3 = False
    layer = None

    def initAlgorithm(self, config):
        """
        Here we define the inputs and output of the algorithm, along
        with some other properties.
        """
        self.parent = None
        self.canvas = iface.mapCanvas()
        self.layerid = ''
        self.srs = QgsCoordinateReferenceSystem("EPSG:32633")
        self.defaultPoint = pointTo3857(QgsPointXY(407719.7, 5279324.9), self.srs)

        # We add the input vector features source. It can have any kind of
        # geometry.
        self.addParameter(
            QgsProcessingParameterString(
                self.ADDRESS,
                'Adresse'
            )
        )

        # We add a feature sink in which to store our processed features (this
        # usually takes the form of a newly created vector layer when the
        # algorithm is run in QGIS).
        self.addParameter(
            QgsProcessingParameterFeatureSink(
                self.OUTPUT,
                self.tr('Output layer')
            )
        )

    def run(self):
        self.processAlgorithm()

    def processAlgorithm(self):
        """
        Here is where the processing itself takes place.
        """

        print("Start processing")


        return {self.OUTPUT: "dest_id"}

    def name(self):
        """
        Returns the algorithm name, used for identifying the algorithm. This
        string should be fixed for the algorithm, and must not be localised.
        The name should be unique within each provider. Names should contain
        lowercase alphanumeric characters only and no spaces or other
        formatting characters.
        """
        return '5 - Hyperlink'

    def displayName(self):
        """
        Returns the translated algorithm name, which should be used for any
        user-visible display of the algorithm name.
        """
        return self.tr(self.name())

    def tr(self, string):
        return QCoreApplication.translate('Processing', string)

    def createInstance(self):
        return Hyperlink()

    def createCustomParametersWidget(self, parent):
        return HyperlinkDialog(self)

    def svgIconPath(self):
        # print(os.path.join(self.homedir, "address_lookup.png"))
        return os.path.abspath("./icons/hyperlink.png")

    def icon(self):
        # todo make dynamic path
        # print(os.path.join(self.homedir, "address_lookup.png"))
        return QIcon(":/plugins/icons/hyperlink.png")
