import sys
import os
from PyQt5.QtWidgets import QMessageBox

try:
    from forst_processing._6_address_lookup.address_lookup import AddressLookup
    from forst_processing._7_reset.reset_settings import ResetForstSettings

    from qgis.core import QgsSettings, QgsPointXY, QgsProject
    from qgis.utils import iface

    result = 0
except:
    result = 1


def zoomStandard():
    iface.mapCanvas().refresh()


def startPlugin():
    AddressLookup()


def execute_addresslookup():
    if QgsSettings().value("addressLookup/mode") == 'load_basemap':
        plugin = AddressLookup()
        plugin.add_basemap()
        plugin.zoomStandard()
        # iface.mapCanvas().refresh()
    elif QgsSettings().value("addressLookup/mode") == 'run_procedure':
        # AddressLookup().add_basemap()
        plugin = AddressLookup()
        plugin.initAlgorithm()
        plugin.show()
    # iface.mapCanvas().refresh()
    # QgsProject().instance().readProject.disconnect(execute_addresslookup)


# Check if default project has old version. If yes, save it in new version
def save_project():
    #QMessageBox.information(iface.mainWindow(), "Information", QgsProject().instance().fileName())
    if os.path.basename(QgsProject().instance().fileName()) == "project_default.qgs":
        #QMessageBox.information(iface.mainWindow(), "Information", u"Update project file.")
        QgsProject().instance().write(QgsProject().instance().fileName())
        QgsProject().instance().oldProjectVersionWarning.disconnect(save_project)


# QgsProject().instance().read(QgsProject().instance().fileName())


def reset_settings():
    if QgsSettings().value("resetForstSettings/mode") == 'yes':
        ResetForstSettings().copy_settings()
        QgsSettings().setValue("resetForstSettings/mode", 'no')


if result == 0:
    QgsProject().instance().oldProjectVersionWarning.connect(save_project)
    QgsProject().instance().readProject.connect(execute_addresslookup)
    QgsProject().instance().projectSaved.connect(reset_settings)